明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1542|回复: 1

请教遍历的问题

[复制链接]
发表于 2005-12-1 21:30:00 | 显示全部楼层 |阅读模式

问题:构造选择集,获取选择集里的特征点并充放在数组中,然后在比较特征点在数组中的位置。以下是代码,但结果总是不正确,虽然调试是通了。

请各位帮忙,谢谢!

void zhao_rank()
{
 // TODO: Implement the command
 int i,cod_number;
 int j;
 long ilast;
 ads_name ent[256];
 float coordinate[256][3];

 acedSSLength(ssname,&ilast);

 AcDbEntity *pEntity;
 AcDbObjectId objId;
 //*********以下程序是将选择集中实体坐标储存在二维数组***********// 
 for(i=1;i<ilast+1;i++)
 {
  acedSSName(ssname,ilast-i,ent);
  acdbGetObjectId(objId,ent);
  acdbOpenObject(pEntity,objId,AcDb::kForRead);//打开点实体
  
  if(pEntity->isKindOf(AcDbCircle::desc()))
  {
   // 显示圆的圆心
   AcDbCircle *pCircle = AcDbCircle::cast(pEntity);
   AcGePoint3d ptCenter;
   ptCenter = pCircle->center();
 
   coordinate[0]=ptCenter[X];
   coordinate[1]=ptCenter[Y];
   coordinate[2]=ptCenter[Z];
  }
  if(pEntity->isKindOf(AcDbPoint::desc()))
  {
   // 显示点的坐标
   AcDbPoint *pPoint = AcDbPoint::cast(pEntity);
   AcGePoint3d ptPoint;
   ptPoint = pPoint->position();
 
   coordinate[0]=ptPoint[X];
   coordinate[1]=ptPoint[Y];
   coordinate[2]=ptPoint[Z];
  }
  pEntity->close();
 }

 //*********以下程序是为实体标号***********// 
for(i=1;i<ilast+1;i++)
{
 cod_number=1;
 acedSSName(ssname,ilast-i,ent);
 acdbGetObjectId(objId,ent);
 acdbOpenObject(pEntity,objId,AcDb::kForRead);//打开点实体
 if(pEntity->isKindOf(AcDbCircle::desc()))
 {
  AcDbCircle *pCircle = AcDbCircle::cast(pEntity);
  AcGePoint3d ptCenter;
  ptCenter = pCircle->center();
  for(j=1;j<ilast+1;j++)
  if(ptCenter[Y]<coordinate[j][1]||(ptCenter[Y]==coordinate[j][1]&&ptCenter[X]<coordinate[j][0]))
   cod_number=cod_number+1;
  acutPrintf("\n %d",cod_number);
 }
 if(pEntity->isKindOf(AcDbPoint::desc()))
 {
  AcDbPoint *pPoint = AcDbPoint::cast(pEntity);
  AcGePoint3d ptPoint;
  ptPoint = pPoint->position();
  for(j=1;j<ilast+1;j++)
   if(ptPoint[Y]<coordinate[j][1]||(ptPoint[Y]==coordinate[j][1]&&ptPoint[X]<coordinate[j][0]))
    cod_number=cod_number+1;
   acutPrintf("\n %d",cod_number);
 }
 

}
 acedSSFree(ssname);
}

发表于 2005-12-5 08:52:00 | 显示全部楼层

用AcDbObjectIdArray

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 03:50 , Processed in 0.227802 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表